package controllers

import (
	"hongze/hongze_cygx/models"
	"hongze/hongze_cygx/services"
	"hongze/hongze_cygx/utils"
	"os"
	"path"
	"time"
)

//资源管理-图片上传，合同上传等
type ResourceController struct {
	BaseAuthController
}

// @Title 图片上传
// @Description 图片上传接口
// @Param   file   query   file  true       "文件"
// @Success 200 新增成功
// @router /image/upload [post]
func (this *ResourceController) Upload() {
	br := new(models.BaseResponse).Init()
	defer func() {
		this.Data["json"] = br
		this.ServeJSON()
	}()
	f, h, err := this.GetFile("file")
	if err != nil {
		br.Msg = "获取资源信息失败"
		br.ErrMsg = "获取资源信息失败,Err:" + err.Error()
		return
	}
	ext := path.Ext(h.Filename)
	dateDir := time.Now().Format("20060102")
	uploadDir := "static/temp/" + dateDir
	err = os.MkdirAll(uploadDir, 777)
	if err != nil {
		br.Msg = "存储目录创建失败"
		br.ErrMsg = "存储目录创建失败,Err:" + err.Error()
		return
	}
	randStr := utils.GetRandStringNoSpecialChar(28)
	fileName := randStr + ext
	fpath := uploadDir + "/" + fileName
	defer f.Close() //关闭上传文件
	err = this.SaveToFile("file", fpath)
	if err != nil {
		br.Msg = "文件上传失败"
		br.ErrMsg = "文件上传失败，Err:" + err.Error()
		return
	}
	//
	////上传到阿里云
	//resourceUrl, err := services.UploadAliyun(fileName, fpath)
	//if err != nil {
	//	br.Msg = "文件上传失败"
	//	br.ErrMsg = "文件上传失败，Err:" + err.Error()
	//	return
	//}

	savePath := uploadDir + time.Now().Format("200601/20060102/")
	savePath += fileName
	//上传到阿里云
	err = services.UploadFileToAliyun("", fpath, savePath)
	if err != nil {
		br.Msg = "文件上传失败"
		br.ErrMsg = "文件上传失败，Err:" + err.Error()
		return
	}
	fileHost := "https://hzstatic.hzinsights.com/"
	resourceUrl := fileHost + savePath
	defer func() {
		os.Remove(fpath)
	}()
	item := new(models.Resource)
	item.ResourceUrl = resourceUrl
	item.ResourceType = 1
	item.CreateTime = time.Now()
	newId, err := models.AddResource(item)
	if err != nil {
		br.Msg = "资源上传失败"
		br.ErrMsg = "资源上传失败,Err:" + err.Error()
		return
	}
	resp := new(models.ResourceResp)
	resp.Id = newId
	resp.ResourceUrl = resourceUrl

	br.Msg = "上传成功"
	br.Ret = 200
	br.Success = true
	br.Data = resp
	return
}

//type ChartPermissionRepMore struct {
//	PermissionName string `description:"名称"`
//}
//
//func init() {
//	var list []*ChartPermissionRepMore
//	//lista := []*ChartPermissionRepMore{{PermissionName: "A1"}}
//	lista := []*ChartPermissionRepMore{{PermissionName: "A1"}, {PermissionName: "A2"}, {PermissionName: "A3"}, {PermissionName: "A4"}, {PermissionName: "A5"}, {PermissionName: "A6"}, {PermissionName: "A7"}, {PermissionName: "A8"}, {PermissionName: "A9"}, {PermissionName: "A10"}}
//	//listb := []*ChartPermissionRepMore{{PermissionName: "B1"}, {PermissionName: "B2"}, {PermissionName: "B3"}, {PermissionName: "B4"}, {PermissionName: "B5"}, {PermissionName: "B6"}, {PermissionName: "B7"}, {PermissionName: "B8"}, {PermissionName: "B9"}, {PermissionName: "B10"}, {PermissionName: "11"}, {PermissionName: "B12"}}
//	listb := []*ChartPermissionRepMore{{PermissionName: "B1"}, {PermissionName: "B2"}, {PermissionName: "B3"}, {PermissionName: "B4"}, {PermissionName: "B5"}, {PermissionName: "B6"}, {PermissionName: "B7"}, {PermissionName: "B8"}, {PermissionName: "B9"}, {PermissionName: "B10"}}
//
//	if len(lista) == 0 {
//		list = listb
//	} else if len(listb) == 0 {
//		list = lista
//	} else {
//		var maxNum, forMinNum int
//		if len(lista)-1 >= len(listb) {
//			maxNum = len(lista)
//		} else {
//			maxNum = len(listb)
//		}
//		list = append(list, lista[0])
//
//		forMinNum = maxNum / 2
//		for i := 0; i <= forMinNum; i++ {
//			for k, v := range listb {
//				if k/2 < i+1 && k/2 >= i {
//					list = append(list, v)
//				}
//			}
//			for k, v := range lista {
//				if k > 2*i && k <= 2*(i+1) && k != 0 {
//					list = append(list, v)
//				}
//			}
//		}
//	}
//	for _, v := range list {
//		fmt.Println(v)
//	}
//}
